package hk.quantr.qemuimporter;

import hk.quantr.dwarf.dwarf.CompileUnit;
import hk.quantr.dwarf.dwarf.Dwarf;
import hk.quantr.dwarf.dwarf.DwarfDebugLineHeader;
import hk.quantr.dwarf.dwarf.DwarfLib;
import hk.quantr.dwarf.dwarf.DwarfLine;
import hk.quantr.javalib.CommonLib;
import hk.quantr.javalib.PropertyUtil;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.sql.BatchUpdateException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.TimeZone;
import java.util.UUID;
import java.util.Vector;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.apache.commons.lang.StringEscapeUtils;
import org.apache.commons.cli.CommandLine;
import org.apache.commons.cli.CommandLineParser;
import org.apache.commons.cli.DefaultParser;
import org.apache.commons.cli.HelpFormatter;
import org.apache.commons.cli.Option;
import org.apache.commons.cli.Options;
import org.apache.commons.cli.ParseException;
import org.apache.commons.dbcp.BasicDataSource;
import org.apache.commons.pool2.impl.GenericObjectPoolConfig;
import redis.clients.jedis.Jedis;
import redis.clients.jedis.JedisPool;
import redis.clients.jedis.Pipeline;

/**
 *
 * @author Peter <peter@quantr.hk>
 */
public class QemuImporter {

	private static final Logger logger = Logger.getLogger(QemuImporter.class.getName());
	static boolean runInPeterMac = false;

	static String mysql_username;
	static String mysql_password;
	static String mysql_host;
	static String mysql_database;
	static BasicDataSource ds = new BasicDataSource();
	static SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

	static {
		if (QemuImporter.runInPeterMac) {
			mysql_username = "assembler";
			mysql_password = "assembler";
			mysql_host = "localhost";
			mysql_database = "assembler";
		} else {
			mysql_username = "assembler";
			mysql_password = "assembler";
			mysql_host = "192.168.0.174";
			mysql_database = "assembler";
		}

		QemuImporter.ds.setUrl("jdbc:mysql://" + QemuImporter.mysql_host + "/" + QemuImporter.mysql_database + "?rewriteBatchedStatements=true");
		QemuImporter.ds.setUsername(QemuImporter.mysql_username);
		QemuImporter.ds.setPassword(QemuImporter.mysql_password);
		QemuImporter.ds.setMinIdle(5);
		QemuImporter.ds.setMaxIdle(10);
		QemuImporter.ds.setMaxOpenPreparedStatements(100000);
	}

	public static void main(String args[]) throws ParseException, FileNotFoundException, IOException, ClassNotFoundException, SQLException {
		Options options = new Options();
		options.addOption("v", "version", false, "display version");
		options.addOption("h", "help");
		options.addOption("i", "input");
		options.addOption("o", "output");
		options.addOption(Option.builder("i")
				.required(true)
				.hasArg()
				.argName("file")
				.desc("input file generated by -D of qemu")
				.build());
		options.addOption(Option.builder("o")
				.required(false)
				.hasArg()
				.argName("file")
				.desc("output json file")
				.build());
		if (Arrays.asList(args).contains("-h") || Arrays.asList(args).contains("--help")) {
			HelpFormatter formatter = new HelpFormatter();
			formatter.printHelp("java -jar qemu-importer.jar [OPTION] <input file>", options);
			return;
		}
		if (Arrays.asList(args).contains("-v") || Arrays.asList(args).contains("--version")) {
			System.out.println("version : " + PropertyUtil.getProperty("main.properties", "version"));

			TimeZone utc = TimeZone.getTimeZone("UTC");
			SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm");
			format.setTimeZone(utc);
			Calendar cl = Calendar.getInstance();
			try {
				Date convertedDate = format.parse(PropertyUtil.getProperty("main.properties", "build.date"));
				cl.setTime(convertedDate);
				cl.add(Calendar.HOUR, 8);
			} catch (java.text.ParseException ex) {
				Logger.getLogger(QemuImporter.class.getName()).log(Level.SEVERE, null, ex);
			}
			System.out.println("build date : " + format.format(cl.getTime()) + " HKT");
			return;
		}

		CommandLineParser cliParser = new DefaultParser();
		CommandLine cmd = cliParser.parse(options, args);
		File file = new File(cmd.getOptionValue("i").replaceFirst("^~", System.getProperty("user.home")));
		BufferedReader reader = new BufferedReader(new FileReader(file));
		String line;

		LinkedHashMap<String, String> values;
		long sequence = 0;

		String dbType = "h2";

		if (dbType.equals("redis")) {
			GenericObjectPoolConfig jedisPoolConfig = new GenericObjectPoolConfig();
			jedisPoolConfig.setMaxTotal(4);
			jedisPoolConfig.setMaxWaitMillis(-1);

			JedisPool jedisPool = new JedisPool(jedisPoolConfig, "192.168.0.239", 6379, 100000);
			Jedis jedis = jedisPool.getResource();
			jedis.auth("fuckwholefamily");
			jedis.select(1);
			Pipeline p = jedis.pipelined();
			outer:
			while (true) {
				int y = 0;
				values = new LinkedHashMap<>();
				do {
					line = reader.readLine();
					if (line == null) {
						break outer;
					}
					String words[] = line.trim().split(" +");
					for (int x = 0; x < words.length; x += 2) {
						words[x] = words[x].replaceAll("/", "_");
//				registers.add(words[x]);
						values.put(words[x], words[x + 1].startsWith("0x") ? words[x + 1] : "0x" + words[x + 1]);
					}
					y++;
				} while (y < 18);

				p.hset("r:" + sequence, values);
				sequence++;
				if (sequence % 10000 == 0) {
					p.sync();
//					p.save();
//					jedis.close();
//					
//					jedis = jedisPool.getResource();
//					jedis.select(1);
//					p = jedis.pipelined();
				}

				if (sequence % 100000 == 0) {
					System.out.printf("%s : %,d\n", sdf.format(new Date()), sequence);
				}
//				if (sequence % 1000000 == 0) {
//					p.save();
//				}
			}
			p.sync();
			p.save();
			jedis.close();
		} else if (dbType.equals("mysql")) {
			Connection conn = null;
			Class.forName("com.mysql.cj.jdbc.Driver");
			conn = QemuImporter.ds.getConnection();
			conn.setAutoCommit(false);
			boolean createColumn = false;
			Statement stmt = conn.createStatement();
			Vector<String> registers = new Vector<>();
			String guid = UUID.randomUUID().toString();

			try {
				outer:
				while (true) {
					int y = 0;
					values = new LinkedHashMap<>();
					do {
						line = reader.readLine();
						if (line == null) {
							break outer;
						}
						String words[] = line.trim().split(" +");
						for (int x = 0; x < words.length; x += 2) {
							words[x] = words[x].replaceAll("/", "_");
							if (createColumn) {
								registers.add(words[x]);
							}
							values.put(words[x], words[x + 1].startsWith("0x") ? words[x + 1] : "0x" + words[x + 1]);

						}

						y++;
					} while (y < 18);

					// create column
					if (createColumn) {
						createColumn = false;
						for (String register : registers) {
							String sql = "ALTER TABLE `qemuRecorder` ADD `" + register + "` BIGINT UNSIGNED NOT NULL;";
							System.out.println(sql);
							conn.createStatement().execute(sql);
						}
					}
					//end create column
					String sql = "INSERT INTO `qemuRecorder` VALUES (0, " + sequence + ",'" + guid + "',now(),'quantr-ubuntu'";
//					if (values.size() > 60) {
//						System.out.println(">60");
//						return;
//					}
					for (Map.Entry me : values.entrySet()) {
//						sql += "," + me.getKey() + "=" + me.getValue();
						sql += "," + me.getValue();
					}
					sql += ")";
					stmt.addBatch(sql);
					if (sequence > 0 && sequence % 100000 == 0) {
						System.out.printf("%s : %,d\n", sdf.format(new Date()), sequence);
						int[] count = stmt.executeBatch();
						conn.commit();
					}
					sequence++;
				}

				int[] count = stmt.executeBatch();
				conn.commit();
			} catch (BatchUpdateException ex) {
				ex.printStackTrace();
				System.out.println(ex.getMessage());
			}
			conn.close();
		} else if (dbType.equals("h2")) {
			HashMap<Long, Data> allData = new HashMap<>();
			initKernelCodeCache(allData);

			Connection conn = null;
			//conn = DriverManager.getConnection("jdbc:h2:e://qemuRecord", "sa", "");
			conn = DriverManager.getConnection("jdbc:h2:tcp://192.168.0.176//root/h2_qemu_recorder/qemuRecord", "sa", "fuck1234shit");
			boolean createEverything = true;
			boolean createColumn = false;
			Statement stmt = conn.createStatement();
			Vector<String> registers = new Vector<>();
			String guid = "admin - linux";//UUID.randomUUID().toString();

			try {
				outer:
				while (true) {
					int y = 0;
					values = new LinkedHashMap<>();
					long pc = -1;
					do {
						line = reader.readLine();
						if (line == null) {
							break outer;
						}
						String words[] = line.trim().split(" +");
						for (int x = 0; x < words.length; x += 2) {
							words[x] = words[x].replaceAll("/", "_");
							if (createColumn) {
								registers.add(words[x]);
							}
							String value = words[x + 1].startsWith("0x") ? words[x + 1] : "0x" + words[x + 1];
							values.put(words[x], value);
							if (words[x].trim().equals("pc")) {
								pc = CommonLib.string2long(value);
							}
						}

						y++;
					} while (y < 18);

					if (createEverything) {
						// create column
						if (createColumn) {
							createColumn = false;
							System.out.println("drop table if exists `qemuRecorder`;");
							conn.createStatement().execute("drop table if exists `qemuRecorder`;");
							conn.createStatement().execute("create table `qemuRecorder`(id bigint auto_increment, sequence bigint, guid varchar(50), date datetime, computer varchar(50));");
							for (String register : registers) {
								//String sql = "ALTER TABLE `qemuRecorder` ADD `" + register + "` BIGINT UNSIGNED NOT NULL;";
								String sql = "ALTER TABLE `qemuRecorder` ADD `" + register + "` varchar(20) NOT NULL;";
								System.out.println(sql);
								conn.createStatement().execute(sql);
							}

							conn.createStatement().execute("ALTER TABLE `qemuRecorder` ADD `lineNo` int;");
							conn.createStatement().execute("ALTER TABLE `qemuRecorder` ADD `filename` varchar(100);");
							conn.createStatement().execute("ALTER TABLE `qemuRecorder` ADD `path` varchar(1000);");
							conn.createStatement().execute("ALTER TABLE `qemuRecorder` ADD `code` varchar(100);");
							conn.createStatement().execute("create INDEX sequence on qemurecorder (sequence);");
						}
						//end create column
					}

					Data data = allData.get(pc);
					String sql = "INSERT INTO `qemuRecorder` VALUES (0, " + sequence + ",'" + guid + "',current_date(), 'quantr-ubuntu'";
//					if (values.size() > 60) {
//						System.out.println(">60");
//						return;
//					}
					for (Map.Entry me : values.entrySet()) {
//						sql += "," + me.getKey() + "=" + me.getValue();
						sql += ",'" + me.getValue() + "'";
					}
					if (data == null) {
						sql += ", null, null, null, null";
					} else {
						sql += ", " + data.lineNo + ", '" + StringEscapeUtils.escapeSql(data.file.getName()) + "', '" + StringEscapeUtils.escapeSql(data.file.getAbsolutePath()) + "', '" + StringEscapeUtils.escapeSql(data.code) + "'";
					}
					sql += ")";
//					System.out.println(sql);
					stmt.addBatch(sql);

					sequence++;
					if (sequence % 100000 == 0) {
						System.out.printf("%s : %,d\n", sdf.format(new Date()), sequence);
						int[] count = stmt.executeBatch();
						conn.commit();
					}
				}

				int[] count = stmt.executeBatch();
				conn.commit();
			} catch (BatchUpdateException ex) {
				ex.printStackTrace();
				System.out.println(ex.getMessage());
			}
			conn.close();
		}
	}

	private static void initKernelCodeCache(HashMap<Long, Data> allData) {
		File file = new File("~/workspace/xv6-riscv/kernel/kernel".replaceFirst("^~", System.getProperty("user.home")));
		final ArrayList<Dwarf> dwarfVector = DwarfLib.init(file, 0, false);
		for (Dwarf dwarf : dwarfVector) {
			System.out.println(dwarf);
			for (CompileUnit cu : dwarf.compileUnits) {
				System.out.println(cu);
				DwarfDebugLineHeader header = cu.dwarfDebugLineHeader;
				for (DwarfLine line : header.lines) {
					try {
						File f = header.filenames.get((int) line.file_num).file;
						String filename = file.getName();
						String path = f.getAbsolutePath();
						String code = Files.readAllLines(Paths.get(path)).get((int) line.line_num - 1);
						System.out.printf("%d, 0x%08x, %s, %s\n", line.line_num, line.address, path, code);

						allData.put(line.address.longValue(), new Data(line.address.longValue(), line.line_num, f, code));
					} catch (Exception ex) {
						System.out.println(line.line_num);
					}
				}
			}
		}
	}
}
